> For the complete documentation index, see [llms.txt](https://docs.mezzanine.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mezzanine.xyz/smart-contracts/source-code/core/mezzguard/blacklistguard.md).

# BlacklistGuard

[Git Source](https://github.com/EntreDevelopers-Lab-Inc/Mezz-Companies/blob/f7a3e84e3dd5bb33c4bd7f77283983f9e8ba20b2/src/core/guards/BlacklistGuard.sol)

**Inherits:** MezzGuard

**Author:** Daniel Yamagata & Jerry Qi & Naveen Ailawadi

A Mezzanine guard that is capable of blacklisting operations that a team can execute. Blacklisted operations are determined by a 'controller', which is typically the Team's parent

\*Operations are blacklisted based on two sets:

* A set of blacklisted contracts
* A set of blacklisted selectors, which are each associated with a contract. For example, if ERC20 contract 'Foo' is part of the contract set, all functions associated with it will be disabled. Similarly, if the function selector of 'bar()' is part of the blacklisted selectors for 'Foo', all calls to 'bar()' by the team will be disabled

## Functions

### checkTransaction

Reverts if 'to' or the function selector of 'data' for 'to' is blacklisted. Will also revert if the operation is a delegate call or relates to the management of the owners, modules, or guard of the 'controlled' Reference: <https://github.com/safe-global/safe-smart-account/blob/f03dfae65fd1d085224b00a10755c509a4eaacfe/contracts/Safe.sol#L173-L190>

```solidity
function checkTransaction(
    address to,
    uint256,
    bytes memory data,
    Enum.Operation operation,
    uint256,
    uint256,
    uint256,
    address,
    address payable,
    bytes memory,
    address
) external view virtual;
```

### coreId

```solidity
function coreId() public pure virtual override returns (bytes32);
```

### version

```solidity
function version() public pure virtual override returns (uint256);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mezzanine.xyz/smart-contracts/source-code/core/mezzguard/blacklistguard.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
